unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TForm1 = class(TForm)
		Image1: TImage;
		procedure FormCreate(Sender: TObject);
	private
		{ Private 錾 }
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
	Canvas: TCanvas;
	I : Char;
	f:system.text;
	x,y:integer;
begin
	Image1.Width := 16 * 128;
	Image1.Height := 24;

	Image1.Picture.Bitmap.Width := 16 * 128;
	Image1.Picture.Bitmap.Height := 24;

	Canvas := Image1.Picture.Bitmap.Canvas;

	Canvas.Font.Name := 'Georgia';
	Canvas.Font.Height := 24;

	for I := #0 to #127 do
	begin
		Canvas.TextOut(Ord(I) * 16 + 8 - Canvas.TextWidth(I) div 2, 0, I);
	end;

	system.assign(f, 'font.vhd');
	system.Rewrite(f);
	writeln(f, 'library IEEE;');
	writeln(f, 'use IEEE.STD_LOGIC_1164.ALL;');
	writeln(f, 'package font is');
	writeln(f, '   type font_table is array (0 to 24 * 16 - 1) of std_logic;');
	for I := #32 to #127 do
	begin
		writeln(f, '   constant font_' + inttohex(ord(I),2) + ' : font_table := (');
		//Write(f, '(');
		for y := 0 to 23 do
		begin
    	//write(f, '(');
			for x := 0 to 15 do
			begin
				write(f, '''');
				write(f, chr(ord('0') + ord(canvas.Pixels[ord(i) * 16 + x, y] <> clWhite)));
				write(f, '''');
				if x < 15 then Write(f, ',');
			end;
    	//write(f, ')');
			if y < 23 then WriteLn(f, ',');
		end;
		//Write(f, ')');
		//if I < #127 then WriteLn(f, ',');
		writeln(f, ');');
	end;
	writeln(f, 'end font;');
	system.close(f);
end;

end.
